package cs4hs11.rsa;

import java.util.Scanner;

import cs4hs11.rsalibrary.RSAMath;

public class RSA {
	public static void main(String[] args) {	
		Scanner in = new Scanner(System.in);
		
		System.out.println("Enter the mth prime and the nth prime to compute");
		long nth = in.nextLong();
		long mth = in.nextLong();
		
		RSAMath math = new RSAMath();
		
		long prime1 = math.getNthPrime(nth);
		long prime2 = math.getNthPrime(mth);
		
		System.out.println("Enter a number to encrypt");
		long message = in.nextLong();
		
		long c = prime1 * prime2;
		
		long m = (prime1 - 1) * (prime2 - 1);
		
		long e = math.coprime(m);
		
		long d = math.mod_inverse(e, m);
		
		long ciphertext = math.endecrypt(message, e, c);
		
		long decrypted = math.endecrypt(ciphertext, d, c);
		
		System.out.println("Message " + message + " encrypted to " + ciphertext + " and decrypted back to " + decrypted);
		
		System.out.println("Used e = " + e + " and d = " + d + ", c = " + c + ", m = " + m + " and totient(m) is " + math.totient(m));
	}	
}